import os

from ament_index_python import get_package_share_directory

from launch import LaunchDescription
from launch.actions import GroupAction, ExecuteProcess
from launch_ros.actions import Node, PushRosNamespace


def generate_launch_description():
    config_file = os.path.join(get_package_share_directory('ws-robot'),
                                       'config',
                                       'modbus-config.yaml')
    group = GroupAction([
        PushRosNamespace('waterstrider'),
        #ExecuteProcess(
        #    cmd=[['v4l2-ctl --device',
        #          ' /dev/video1',
        #          ' --stream-mmap 1 --set-fmt-video=',
        #          'width=320,height=200,pixelformat=MJPG',
        #          ' --stream-to - | raspivid_mjpeg_server -d 0'
        #         ]],         
        #    name="stream_video",
        #    shell=True,
        #),
        Node(
            package='usb_cam',
            executable='usb_cam_node_exe',
            output='screen',
            parameters=[
                {"video_device":"/dev/video1"},
                {"pixel_format":"mjpeg2rgb"},
                {"image_height": 480},
                {"image_width": 640},
            ],
        ),
        Node(
            package='ros_modbus_device_driver',
            executable='modbus_device_driver.py',
            output='screen',
            parameters=[config_file
            ],
        ),
    ])
    return LaunchDescription([
        group
    ])
